local scopes = {
	["see a wooden gate with an elaborate carving of an armchair on it."] = "pygmy pygment",
	["see a wooden gate with an elaborate carving of a cowardly%-looking man on it."] = "wussiness potion",
	["see a wooden gate with an elaborate carving of a banana peel on it."] = "gremlin juice",
	["see a wooden gate with an elaborate carving of a coiled viper on it."] = "adder bladder",
	["see a wooden gate with an elaborate carving of a rose on it."] = "(Sugar Rush)",
	["see a wooden gate with an elaborate carving of a glum teenager on it."] = "thin black candle",
	["see a wooden gate with an elaborate carving of a hedgehog on it."] = "super-spiky hair gel",
	["see a wooden gate with an elaborate carving of a raven on it."] = "Black No. 2",
	["see a wooden gate with an elaborate carving of a smiling man smoking a pipe on it."] = "Mick's IcyVapoHotness Rub",

	["catch a glimpse of a flaming katana."] = "frigid ninja stars",
	["catch a glimpse of a translucent wing."] = "spider web",
	["see a fancy%-looking tophat."] = "sonar-in-a-biscuit",
	["see a flash of albumen."] = "black pepper",
	["see a giant white ear."] = "pygmy blowgun",
	["see a huge face made of Meat."] = "meat vortex",
	["see a large cowboy hat."] = "chaos butterfly",
	["see a periscope."] = "photoprotoneutron torpedo",
	["see a slimy eyestalk."] = "fancy bath salts",
	["see a strange shadow."] = "inkwell",
	["see moonlight reflecting off of what appears to be ice."] = "hair spray",
	["see part of a tall wooden frame."] = "disease",
	["see some amber waves of grain."] = "bronzed locust",
	["see some long coattails."] = "Knob Goblin firecracker",
	["see some pipes with steam shooting out of them."] = "powdered organs",
	["see some sort of bronze figure holding a spatula."] = "leftovers of indeterminate origin",
	["see the neck of a huge bass guitar."] = "mariachi G-string",
	["see what appears to be the North Pole."] = "NG",
	["see what looks like a writing desk."] = "plot hole",
	["see the tip of a baseball bat."] = "baseball",
	["see what seems to be a giant cuticle."] = "razor-sharp can lid",

	["see a formidable stinger."] = "tropical orchid",
	["see a wooden beam."] = "stick of dynamite",
	["see a pair of horns."] = "barbed-wire fence",
}

add_printer("/campground.php", function() -- this is also called when using mystical bookshelf skills etc.
	local inventory = nil
	have_item = function(name)
		if not inventory then
			inventory = str_to_table(get_inventory_counts())
		end
		have_amount = 0
		local ids = {}
		if name == "(Sugar Rush)" then
			ids = { 540, 617, 905, 908, 909, 911, 1163, 2088, 2342, 2734, 3760, 4393, 4394, 4395, 4526 }
		else
			ids = { get_itemid(name) }
		end
		for _, id in pairs(ids) do
			have_amount = have_amount + (inventory[id] or 0)
		end
		return (have_amount > 0)
	end

	for from, to in pairs(scopes) do
		if text:match(from) then
			if have_item(to) then
				text = text:gsub(from, [[%0 (<span style="color: green">]]..to..[[</span>)]])
			else
				text = text:gsub(from, [[%0 <b>(<span style="color: darkorange">]]..to..[[</span>)</b>]])
			end
		end
	end
end)

add_processor("/campground.php", function()
	itemsneeded = {}
	for from, to in pairs(scopes) do
		if (string.match(text, from)) then
			table.insert(itemsneeded, to)
		end
	end
	if (table.maxn(itemsneeded) > 0) then
		set_ascension_state("zone.lair.itemsneeded", table_to_str(itemsneeded))
	end
end)

add_printer("/lair1.php", function()
	gateitems = {
		["Gate of Hilarity"] = { effect = "Comic Violence", item = "gremlin juice" },
		["Gate of Humility"] = { effect = "Wussiness", item = "wussiness potion" },
		["Gate of Morose Morbidity and Moping"] = { effect = "Rainy Soul Miasma", item = "thin black candle" },
		["Gate of Slack"] = { effect = "Extreme Muscle Relaxation", item = "Mick's IcyVapoHotness Rub" },
		["Gate of Spirit"] = { effect = "Woad Warrior", item = "pygmy pygment" },
		["Gate of the Porcupine"] = { effect = "Spiky Hair", item = "super-spiky hair gel" },
		["Twitching Gates of The Suc Rose"] = { effect = "Sugar Rush" },
		["Gate of the Viper"] = { effect = "Deadly Flashing Blade", item = "adder bladder" },
		["Locked Gate"] = { effect = "Locks Like the Raven", item = "Black No. 2" },

		["Gate of Flame"] = { effect = "Spicy Mouth", item = "jaba&ntilde;ero-flavored chewing gum" },
		["Gate of Intrigue"] = { effect = "Mysteriously Handsome", item = "handsomeness potion" },
		["Gate of Machismo"] = { effect = "Engorged Weapon", item = "Meleegra&trade; pills" },
		["Gate of Mystery"] = { effect = "Mystic Pickleness", item = "pickle-flavored chewing gum" },
		["Gate of the Dead"] = { effect = "Hombre Muerto Caminando", item = "marzipan skull" },
		["Gate of Torment"] = { effect = "Tamarind Torment", item = "tamarind-flavored chewing gum" },
		["Gate of Zest"] = { effect = "Spicy Limeness", item = "lime-and-chile-flavored chewing gum" },

		["Gate of Light"] = { effect = "Izchak's Blessing", potion = "blessing" },
		["Gate of That Which is Hidden"] = { effect = "Object Detection", potion = "detection" },
		["Gate of the Mind"] = { effect = "Strange Mental Acuity", potion = "acuity" },
		["Gate of the Ogre"] = { effect = "Strength of Ten Ettins", potion = "strength" },
		["Gate that is Not a Gate"] = { effect = "Teleportitis", potion = "teleportation" },
	}
	local need = {}
	refresh_status()
	refresh_inventory()
	local dod_tbl = get_dod_potion_status()
	local dod_reverse = {}
	for a,b in pairs(dod_tbl) do
		dod_reverse[b] = a
	end
	local pwd = get_session_state("pwd")
	text = text:gsub([[</head>]], [[<script type="text/javascript" src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>
<script type="text/javascript">
	function use_item_result(link, pagetext) {
		if (pagetext.match(/You acquire an effect:/)) {
			link.style.color = 'gray';
		} else {
			link.style.color = 'red';
		}
	}
	function use_item(link, itemid) {
		$.ajax({ type:'GET', url:'/inv_use.php', cache:false, data:{ pwd:"]] .. pwd .. [[", whichitem:itemid, ajax:1 }, global:false, success: function(retdata) { use_item_result(link, retdata); } });
	}
</script>%0]])
	for from, to in pairs(gateitems) do
		if text:match("<p>&quot;Through the "..from..".-&quot;") then
			local effect_status = "(???)"
			if buff(to.effect) then
				effect_status = [[(<span style="color: grey;">]]..to.effect..[[</span>)]]
			elseif (to.item) or (to.potion and dod_reverse[to.potion]) then
				local name = to.item or dod_reverse[to.potion]
				if have(name) then
					effect_status = [[(<a href="#" onclick="javascript:use_item(this, ]]..get_itemid(name)..[[); return false;" style="color: green;">]]..name..[[</a>]] .." ("..to.effect..")".. [[)]]
				else
					effect_status = [[<b>(<span style="color: darkorange;">]]..name..[[</span>]].." ("..to.effect..")"..[[)</b>]]
				end
			else
				effect_status = [[<b>(<span style="color: darkorange;">(]]..to.effect..[[)</span>)</b>]]
			end
			text = text:gsub("(<p>&quot;Through the "..from..".-&quot;)( <p>)", "%1 " .. effect_status .. "%2")
			table.insert(need, to)
		end
	end
end)


add_printer("/lair2.php", function ()
	text = string.gsub(text, "(<input type=hidden name=prepreaction value=\"sorcriddle1\">What am I%? <input name=answer class=text type=text size=10)(>)", "%1 value=\"fish\"%2")
	text = string.gsub(text, "(<input type=hidden name=prepreaction value=\"sorcriddle2\">Who are we%? <input name=answer class=text type=text size=10)(>)", "%1 value=\"phish\"%2")
	text = string.gsub(text, "(<input type=hidden name=prepreaction value=\"sorcriddle3\">What am I%? <input name=answer class=text type=text size=10)(>)", "%1 value=\"fsh\"%2")
	if string.find(text, "<input type=hidden name=prepreaction value=\"sequence\">First:") then
		choices = { seq1="Up", seq2="Up", seq3="Down", seq4="Down", seq5="Left", seq6="Right", seq7="Left", seq8="Right", seq9="B", seq10="A" }
		for a, b in pairs(choices) do
			text = string.gsub(text, "(<select name="..a..">.-<option value=\".-\")(>"..b.."</option>.-</select>)", "%1 selected=\"selected\"%2")
		end
	end
end)

add_processor("/lair6.php", function ()
	if string.find(text, "As you approach the door, you notice that someone has scrawled a message on it with a pencil: &quot;BEWARE: One of the guards always tells the truth, one of them always lies, one of them alternates between the two, and one craves the taste of human flesh!&quot; Ominous.") then
		if string.find(text, "You're full of it") then
			first = string.match(text, "&quot;Well,&quot; says South, &quot;the first digit is ([0-9]).&quot;")
			second = string.match(text, "North grumbles, &quot;It's definitely more than that %-%- it's ([0-9]).&quot;")
			third = string.match(text, "&quot;No, it is ([0-9]), I'm sure of it,&quot; says North.")
		else
			truth, third = string.match(text, "&quot;Don't listen to him,&quot; says (.-). &quot;It's ([0-9]).&quot;")
			second = string.match(text, "&quot;The second digit now %-%- that's ([0-9]),&quot; says South.")
			if (truth == "South") then
				first = string.match(text, "&quot;Well,&quot; says South, &quot;the first digit is ([0-9]).&quot;")
			elseif (truth == "East") then
				first = string.match(text, "&quot;No it isn't,&quot; says East. &quot;It's ([0-9]).&quot;")
			end
		end
		print("lair6 door", first, second, third)
		if first and second and third then
			set_ascension_state("zone.lair.doorcode", first..second..third)
		end
	end
end)

add_printer("/lair6.php", function ()
	if text:match("You approach the heavy door.  Next to it is a panel with a bunch of buttons on it.  On the buttons are numbers.") then
		local code = get_ascension_state("zone.lair.doorcode")
		if code ~= "" then
			text = string.gsub(text, "(<input type=text class=text size=5 name=code)(>)", "%1 value=\""..code.."\"%2")
		end
	end
end)

add_automator("/lair6.php", function ()
	if params.place == "0" then
		if text:match("At the top of the steps leading to the Sorceress' Chamber, you encounter two doors.") then
			code = set_ascension_state("zone.lair.doorcode", "")
			post_page("/lair6.php", { preaction = "lightdoor" })
			code = get_ascension_state("zone.lair.doorcode")
			print("lair6 code", code, "params", table_to_str(params))
			if code ~= "" then
				text = post_page("/lair6.php", { action = "doorcode", code = code })
			end
		end
	end
	if params.place == "3" or params.place == "4" then
		if text:match("Disappointed by your failure, you stomp off in a huff, and stub your toe.") then
			which = text:match([[<img src="http://images.kingdomofloathing.com/adventureimages/([a-z]+).gif" width=100 height=100>]])
			print("Sorceress familiar:", which)
			local familiar_lookup = {
				barrrnacle = { id = 4, name = "Angry Goat", },
				goat = { id = 1, name = "Mosquito", },
				lime = { id = 3, name = "Levitating Potato", },
				mosquito = { id = 5, name = "Sabre-Toothed Lime", },
				potato = { id = 8, name = "Barrrnacle", },
			}
			if familiar_lookup[which] then
				print("Familiar used to defeat it:", familiar_lookup[which].name)
				status = str_to_table(get_status_info())
				get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(familiar_lookup[which].id) })
				newstatus = str_to_table(get_status_info())
				weight = get_familiar_weight()
				if tonumber(newstatus.familiar) == familiar_lookup[which].id then
					if weight and weight >= 20 then
						newtext = get_page("/lair6.php", { place = params.place })
						if string.match(newtext, "You move further into the tower, while huge chunks of stone fall from the walls for no good reason.") then
							text = newtext
							print("Won vs NS familiar")
						else
							print("Error fighting NS familiar")
							error("Error, expected to win this fight with a " .. tostring(weight) .. " lbs. " .. familiar_lookup[which].name .. ".")
						end
					else
						print("Familiar weight is only", weight)
					end
				else
					print("Missing familiar")
				end
				get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = status.familiar })
			else
				print("Unknown NS familiar", which)
			end
		end
	end
end)

add_automator("/lair1.php", function()
	if params.action == "mirror" then
		if text:contains("You try to break it") then
			pwd = get_session_state("pwd") -- inserting pwd, boo!
			get_page("/inv_equip.php", { action = "unequipall", pwd = pwd })
			text, url = get_page(path, params)
		end
	end
end)

add_automator("/lair2.php", function()
	if params.action == "statues" then
		if not text:match("You gather up your instruments") then
			pwd = get_session_state("pwd") -- inserting pwd, boo!
			refresh_status()
			refresh_inventory()
			if not have("makeshift SCUBA gear") then
				post_page("/lair2.php", { prepreaction = "sorcriddle1", answer = "fish" })
				post_page("/lair2.php", { prepreaction = "sorcriddle2", answer = "phish" })
				post_page("/lair2.php", { prepreaction = "sorcriddle3", answer = "fsh" })
				plunge_items("fish hose", "fishbowl")
				plunge_items("hosed fishbowl", "fishtank")
			end
			equip_item("makeshift SCUBA gear", 3)
			get_page("/lair2.php", { action = "odor" })

			post_page("/lair2.php", { prepreaction = "sequence", seq1= "up", seq2 = "up", seq3 = "down", seq4 = "down", seq5 = "left", seq6 = "right", seq7 = "left", seq8 = "right", seq9 = "b", seq10 = "a" })

			if not have("stone tablet (Sinister Strumming)") then
				local fam = familiarid()
				switch_familiarid(17) -- star starfish
				equip_item("star sword")
				equip_item("star staff")
				equip_item("star crossbow")
				equip_item("star hat")
				post_page("/lair2.php", { prepreaction = "starcage" })
				switch_familiarid(fam)
			end

			get_page("/inv_equip.php", { action = "unequipall", pwd = pwd })
			text, url = get_page(path, params)
		end
	end
end)

add_interceptor("/lair6.php", function()
	if params.place == "1" then
		pwd = get_session_state("pwd") -- inserting pwd, boo!
		refresh_status()
		local weapid = equipment().weapon
		local offhandid = equipment().offhand
		equip_item("huge mirror shard")
		text, url = get_page(path, params)
		if weapid then equip_itemid(weapid) end
		if offhandid then equip_itemid(offhandid) end
		return text, url
	end
end)
