-- the haunted pantry
add_choice_text("Trespasser", { -- choice adventure number: 117
	["Tackle him"] = "<b>Fight Knob Goblin Assistant Chef</b>",
	["Challenge him to a magical duel"] = "Gain 4-8 mysticality",
	["Wait and see what happens"] = "Get 1-5 starting area items",
})

add_choice_text("The Singing Tree", { -- choice adventure number: 116
	["&quot;Sing a sad song&quot;"] = "Gain 4-5 mysticality",
	["&quot;Sing a happy song&quot;"] = "Gain 4-5 moxie",
	["&quot;Sing whatever you want&quot;"] = "Get 7-8 mysticality or a whiskey and soda",
	["&quot;No singing, thanks.&quot;"] = { leave_noturn = true, good_choice = true },
})

add_choice_text("Oh No, Hobo", { -- choice adventure number: 115
	["Give him a beating"] = "<b>Fight a drunken half-orc hobo</b>",
	["Give him some Meat"] = "Get Good Karma or nothing",
	["Give him the business"] = "Get 5-10 meat and 3-4 mysticality and moxie",
})

add_choice_text("The Baker's Dilemma", { -- choice adventure number: 114
	["&quot;I'll see what I can do.&quot;"] = "Get unlit birthday cake",
	["&quot;Sorry, I'm busy right now.&quot;"] = { leave_noturn = true, good_choice = true },
	["&quot;Hey, what's that over there?&quot;"] = "Gain 4-5 moxie and 15-20 meat",
})

add_processor("/desc_item.php", function()
	glyph = text:match([[title="(Arcane Glyph #[0-9]+)"]])
	if glyph then
		tbl = get_ascension_state("zone.manor.glyphs")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		name = text:match("<b>(dusty bottle of [A-Za-z ]+)</b>")
		print(name .. " -> " .. glyph)
		tbl[glyph] = name
		set_ascension_state("zone.manor.glyphs", table_to_str(tbl))
	end
end)

add_processor("/manor3.php", function()
	if text:match("Your eyes are drawn to a pattern of odd glyphs") then
		tbl = get_ascension_state("zone.manor.glyphs")
		if (tbl == "") then return end
		tbl = str_to_table(tbl)
		wines_needed = {}
		for x in text:gmatch([[title="(Arcane Glyph #[0-9]+)"]]) do
			print("glyph:"..x.." -> "..tostring(tbl[x]))
			table.insert(wines_needed, tbl[x])
		end
		set_ascension_state("zone.manor.wines needed", table_to_str(wines_needed))
	end
end)

add_printer("/manor3.php", function()
	if text:match("How curious.") then
		tbl = get_ascension_state("zone.manor.wines needed")
		if (tbl == "") then return end
		tbl = str_to_table(tbl)
		prints = {}
		table.insert(prints, "<ol>")
		for _, x in pairs(tbl) do
			table.insert(prints, "<li>" .. x .. "</li>")
		end
		table.insert(prints, "</ol>")

		local wines_needed_list = get_ascension_state("zone.manor.wines needed")
		if (wines_needed_list == "") then wines_needed_list = {} else wines_needed_list = str_to_table(wines_needed_list) end
		local count = 0
		local got = 0
		refresh_inventory()
		for _, wine in pairs(wines_needed_list) do
			count = count + 1
			if have(wine) then
				got = got + 1
			end
		end

		if count == 3 then
			if got == 3 then
				table.insert(prints, [[<a href="automate-pour-manor-wines" style="color:green;">{Pour all 3}</a>]])
			else
				table.insert(prints, [[<span style="color:gray;">{Pour all 3}</span>]])
			end
		end

		text = text:gsub("How curious.", function(x) return x .. "<br>" .. table.concat(prints) end)
	end
end)

add_processor("item drop", function ()
	if adventure_zone then
		if item_name:match("^dusty bottle of ") then
			print("bottle drop", adventure_zone, item_image, item_name, text)
			tbl = get_ascension_state("zone.manor.wine cellar bottles")
			if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
			if not tbl[adventure_zone] then
				tbl[adventure_zone] = {}
			end
			tbl[adventure_zone][item_name] = true
			set_ascension_state("zone.manor.wine cellar bottles", table_to_str(tbl))
		end
	end
end)


add_printer("/manor3.php", function ()
	if get_ascension_state("zone.manor.wines needed") == "" then return end
	tbl = get_ascension_state("zone.manor.wine cellar bottles")
	if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end

	quadrants = {
		{ ["dusty bottle of Marsala"] = true, ["dusty bottle of Merlot"] = true, ["dusty bottle of Muscat"] = true }, -- 1
		{ ["dusty bottle of Marsala"] = true, ["dusty bottle of Pinot Noir"] = true, ["dusty bottle of Zinfandel"] = true }, -- 2
		{ ["dusty bottle of Merlot"] = true, ["dusty bottle of Pinot Noir"] = true, ["dusty bottle of Port"] = true }, -- 3
		{ ["dusty bottle of Muscat"] = true, ["dusty bottle of Port"] = true, ["dusty bottle of Zinfandel"] = true }, -- 4
	}

	permutations = {
		{ [178] = 1, [179] = 2, [180] = 3, [181] = 4 }, -- 1
		{ [178] = 1, [179] = 2, [180] = 4, [181] = 3 }, -- 2
		{ [178] = 1, [179] = 3, [180] = 2, [181] = 4 }, -- 3
		{ [178] = 1, [179] = 3, [180] = 4, [181] = 2 }, -- 4
		{ [178] = 1, [179] = 4, [180] = 2, [181] = 3 }, -- 5
		{ [178] = 1, [179] = 4, [180] = 3, [181] = 2 }, -- 6
		{ [178] = 2, [179] = 1, [180] = 3, [181] = 4 }, -- 7
		{ [178] = 2, [179] = 1, [180] = 4, [181] = 3 }, -- 8
		{ [178] = 2, [179] = 3, [180] = 1, [181] = 4 }, -- 9
		{ [178] = 2, [179] = 3, [180] = 4, [181] = 1 }, -- 10
		{ [178] = 2, [179] = 4, [180] = 1, [181] = 3 }, -- 11
		{ [178] = 2, [179] = 4, [180] = 3, [181] = 1 }, -- 12
		{ [178] = 3, [179] = 1, [180] = 2, [181] = 4 }, -- 13
		{ [178] = 3, [179] = 1, [180] = 4, [181] = 2 }, -- 14
		{ [178] = 3, [179] = 2, [180] = 1, [181] = 4 }, -- 15
		{ [178] = 3, [179] = 2, [180] = 4, [181] = 1 }, -- 16
		{ [178] = 3, [179] = 4, [180] = 1, [181] = 2 }, -- 17
		{ [178] = 3, [179] = 4, [180] = 2, [181] = 1 }, -- 18
		{ [178] = 4, [179] = 1, [180] = 2, [181] = 3 }, -- 19
		{ [178] = 4, [179] = 1, [180] = 3, [181] = 2 }, -- 20
		{ [178] = 4, [179] = 2, [180] = 1, [181] = 3 }, -- 21
		{ [178] = 4, [179] = 2, [180] = 3, [181] = 1 }, -- 22
		{ [178] = 4, [179] = 3, [180] = 1, [181] = 2 }, -- 23
		{ [178] = 4, [179] = 3, [180] = 2, [181] = 1 }, -- 24
	}

	for z, ztbl in pairs(tbl) do
		for name, _ in pairs(ztbl) do
--~ 			print("manor3", z, name)
			for i = 1, 24 do
				if permutations[i] then
					q = permutations[i][z]
					if q and not quadrants[q][name] then
						permutations[i] = nil
					end
				end
			end
		end
	end

	wines = {}
	valid_permutations = 0

	for _, ptbl in pairs(permutations) do
		for z, q in pairs(ptbl) do
			for name, _ in pairs(quadrants[q]) do
				if not wines[z] then wines[z] = {} end
				if not wines[z][name] then wines[z][name] = 0 end
				wines[z][name] = wines[z][name] + 1
			end
		end
		valid_permutations = valid_permutations + 1
	end

--~ 	for z, wtbl in pairs(wines) do
--~ 		print("wine", z, table_to_str(wtbl))
--~ 	end

	wines_needed_list = get_ascension_state("zone.manor.wines needed")
	if (wines_needed_list == "") then wines_needed_list = {} else wines_needed_list = str_to_table(wines_needed_list) end
	wines_needed_status = {}
	if not text:match("Summoning Chamber") then
		refresh_inventory()
		for _, wine in pairs(wines_needed_list) do
			if have(wine) then
				wines_needed_status[wine] = "have"
			else
				wines_needed_status[wine] = "need"
			end
		end
	end
	
	function get_zone_wines(z)
		wine_names = {}
		for wine, count in pairs(wines[z]) do
			table.insert(wine_names, wine)
		end
		table.sort(wine_names)
		retstr = ""
		for _, wine in pairs(wine_names) do
			if wines[z][wine] == valid_permutations then
				starttag, winestr, endtag = "<td>", wine:gsub("dusty bottle of ", ""), "</td>"
			else
				starttag, winestr, endtag = [[<td style="font-size: 66%%;">]], wine:gsub("dusty bottle of ", "") .. ": " .. string.format("%.1f%%%%", 100 * wines[z][wine] / valid_permutations), "</td>"
			end
			if wines_needed_status[wine] == "need" then
				winestr = [[<span style="color: darkorange">]] .. winestr .. "</span>"
			elseif wines_needed_status[wine] == "have" then
				winestr = [[<span style="color: green">]] .. winestr .. "</span>"
			else
				winestr = [[<span style="color: gray">]] .. winestr .. "</span>"
			end
			retstr = retstr .. "<tr>" .. starttag .. winestr .. endtag .. "</tr>"
		end
		return [[<table style="height: 100px; vertical-align: middle;"><tr><td><table style="text-align: center;">]] .. retstr .. "</table></td></tr></table>"
	end
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=178">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; right: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(178) .. [[</div>%2</div>%3]])
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=179">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; left: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(179) .. [[</div>%2</div>%3]])
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=180">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; right: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(180) .. [[</div>%2</div>%3]])
	text = text:gsub([[(<td width=100 height=100>)(<a href="adventure.php%?snarfblat=181">.-)(</td>)]], [[%1<div style="position: relative;"><div style="position: absolute; left: 100px; width: 100px; height: 100px;">]] .. get_zone_wines(181) .. [[</div>%2</div>%3]])
end)

--~ billiards room

add_choice_text("Minnesota Incorporeals", {
	["Break"] = "Gain moxie",
	["Let the ghost break"] = "<b>Unlock library</b> or gain muscle",
	["Run away"] = { leave_noturn = true },
})

add_choice_text("Broken", {
	["Go for a solid"] = "<b>Unlock library</b> or gain mysticality",
	["Go for a stripe"] = "Gain muscle",
	["Go for a walk"] = { leave_noturn = true },
})

add_choice_text("A Hustle Here, a Hustle There", {
	["Go for the 8-ball"] = "<b>Unlock library</b> (with Chalky Hand active)",
	["Play defensively"] = "Gain mysticality",
	["Chicken out"] = { leave_noturn = true },
})


-- library

add_choice_text("Take a Look, it's in a Book!", {
	["Read &quot;The Rise of the House of Spookyraven&quot;"] = { text = "Read stories...", disabled = true },
	["Read &quot;The Better Haunted Homes and Conservatories Cookbook&quot;"] = "Get a random cooking recipe",
	["Read &quot;Ancient Forbidden Unspeakable Evil, a Love Story&quot;"] = "Gain myst or mox or myst spookyraven skill...",
	["Reading is for losers.  I'm outta here."] = { leave_noturn = true },

	["Read &quot;The Fall of the House of Spookyraven&quot;"] = "Unlock tombstone adventure...",
	["Read &quot;To Serve Man... Delicious Cocktails&quot;"] = "Get a random mixing recipe",
	["Read &quot;Ancient Forbidden Unspeakable Yoga, a Beginner's Guide&quot;"] = "Gain muscle and take damage",
})

add_choice_text("Naughty, Naughty...", {
	["Read Chapter 1:  Tuesdays with Abhorrent Fiends"] = "Gain myst",
	["Read Chapter 2:  The Nether Planes on 350 Meat a Day"] = "Gain mox",
	["Read Chapter 3:  Twisted, Curdled, Corrupt Energy and You"] = "Gain myst spookyraven skill or take damage",
})

add_choice_text("History is Fun!", { -- choice adventure number: 87
	["Read Chapter 1: Things Get Weirder"] = { disabled = true },
	["Read Chapter 2: Stephen and Elizabeth"] = { text = "Unlock key adventure in the conservatory" },
	["Read Chapter 3:  Last Days"] = { disabled = true },
})

-- bathroom

add_choice_text("Having a Medicine Ball", { -- choice adventure number: 105
	["Gaze deeply into the mirror"] = { text = "Gain mysticality", good_choice = true },
	["Open it and see what's inside"] = { text = "Get item or leave" },
	["Say &quot;Guy made of bees.&quot;"] = { text = "Repeat 5 times to fight The Guy Made Of Bees" },
})

add_choice_text("Don't Hold a Grudge", { -- choice adventure number: 402
	["Armwrestle it"] = { text = "Gain muscle" },
	["Declare a thumb war"] = { text = "Gain mysticality", good_choice = true },
	["Shake it"] = { text = "Gain moxie" },
})


--~ add_choice_text("Having a Medicine Ball", {
--~ 	["Gaze deeply into the mirror"] = { text = "Gain myst", good_choice = true },
--~ })

--~ add_choice_text("Don't Hold a Grudge", {
--~ 	["Declare a thumb war"] = { text = "Gain myst", good_choice = true },
--~ })

-- bedroom

add_choice_text_conditional("One Nightstand", {
	["Check the top drawer"] = "Get coin purse",
	["Check the bottom drawer"] = "Fight nightstand",
	["Look under the nightstand"] = "Spookyraven skill item",
}, function() return text:contains("mahogany") end)

add_choice_text_conditional("One Nightstand", {
	["Open the top drawer"] = "Gain meat",
	["Open the bottom drawer"] = "Gain mysticality",
	["Look behind the nightstand"] = { getitem = "Lord Spookyraven's spectacles" },
}, function() return text:contains("ornately") end)

add_choice_text_conditional("One Nightstand", {
	["Look in the top drawer"] = "Get wallet",
	["Look in the bottom drawer"] = "Gain muscle",
	["Kick it and see what happens"] = "Fight nightstand",
}, function() return text:contains("white") end)

add_choice_text_conditional("One Nightstand", {
	["Check the top drawer"] = "Gain moxie + unlock key",
	["Check the bottom drawer"] = "Gain ballroom key",
	["Investigate the jewelry"] = "Fight mistress",
}, function() return text:contains("wooden") end)

-- ballroom

add_choice_text("Strung-Up Quartet", {
	["&quot;Play 'Provare Compasione Per El Sciocco'&quot;"] = "Set song to +5 ML",
	["&quot;Play 'Sono Un Amanten Non Un Combattente'&quot;"] = "Set song to +5% non-combats",
	["&quot;Play 'Le Mie Cose Favorite'&quot;"] = "Set song to +5% items",
	["&quot;Play nothing, please.&quot;"] = "Disable song (does not cost an adventure)",
})

add_choice_text("Curtains", {
	["Investigate the organ"] = "Fight an organist or get moxie spookyraven skill",
	["Watch the dancers"] = "Gain moxie",
	["Pay no attention to the stuff in front of the curtain"] = { leave_noturn = true },
})

add_processor("/inv_use.php", function ()
	if text:contains("You pencil your name in on the last line of the dance card, and it evaporates in a puff of ectoplasm.") then
		turnsplayed = tonumber(get_turns_this_run())
		dance_turn = turnsplayed + 3
		set_ascension_state("dance card turn", tostring(dance_turn))
--~ 		addcounter("Dance card", 3)
	end
end)

add_printer("/charpane.php", function ()
	dance_card_turn = tonumber(get_ascension_state("dance card turn"))
	if dance_card_turn then
		turnsthisrun = tonumber(string.match(text, "var turnsthisrun = ([0-9]+);"))
		turnsleft = dance_card_turn - turnsthisrun
		if turnsleft >= 0 then
			color = nil
			link = nil
			if turnsleft == 0 then
				color = "green"
				link = "adventure.php?snarfblat=109"
			end
			print_charpane_value({ name = "Dance card", value = tostring(turnsleft), color = color, link = link })
		end
	end
end)

-- gallery
add_choice_text("Out in the Garden", { -- choice adventure number: 89
	["The first knight"] = "Get SC skill / fight knight (+spooky damage)",
	["The second knight"] = "Get TT skill / <b>fight knight (+ML)</b>",
	["The two maidens"] = "Get Dreams and Lights or lose HP",
})

-- louvre
add_processor("/choice.php", function ()
	if adventure_title == "Louvre It or Leave It " then
--~ 		print("louvre", choice_adventure_number, table_to_str(params))
		whichchoice = params.whichchoice
		option = params.option
		if whichchoice == "" then whichchoice = nil else whichchoice = tonumber(whichchoice) end
		if option == "" then option = nil else option = tonumber(option) end
		if choice_adventure_number and whichchoice and option then
			if choice_adventure_number ~= 91 then -- TODO: Hmm, bit hardcoded, check for some text instead?
				set_ascension_state("louvre.map.adventure." .. tostring(whichchoice) .. ".choice." .. tostring(option), "choice " .. tostring(choice_adventure_number))
--~ 				print("setting", whichchoice, option, "choice", choice_adventure_number)
--~ 			else
--~ 				print("louvre debug", choice_adventure_number, text)
			end
		end
		set_ascension_state("louvre.lastadventure", tostring(choice_adventure_number))
	else
--~ 		print("not-louvre", choice_adventure_number, table_to_str(params), adventure_title)
		lastlouvre = get_ascension_state("louvre.lastadventure")
		if lastlouvre == "" then lastlouvre = nil else lastlouvre = tonumber(lastlouvre) end
--~ 		print("lastlouvre", lastlouvre)
		if lastlouvre then
			whichchoice = params.whichchoice
			option = params.option
			if whichchoice == "" then whichchoice = nil else whichchoice = tonumber(whichchoice) end
			if option == "" then option = nil else option = tonumber(option) end
--~ 			print("which, opt", whichchoice, option)
			if lastlouvre and whichchoice and option and lastlouvre == whichchoice then
--~ 				print("louvre-result", choice_adventure_number, table_to_str(params), adventure_title)
				results = {}
				results["&quot;Hey, Wayne,&quot; he replies."] = "Gain muscle"
				results["the scene fills you with new insight as to the nature of the universe"] = "Gain mysticality"
				results["only playing for dog biscuits"] = "Gain moxie"
				results["Nothing better than a picnic on a bright summer day such as this"] = "Get Manetwich"
				results["a burly bearded guy in a wifebeater and straw hat gives you a funny look"] = "Get bottle of Pinot Renoir"
				results["bed and inspect the awkwardly slanted nightstand"] = "Get bottle of Vangoghbitussin"
				for a, b in pairs(results) do
					if text:contains(a) then
						set_ascension_state("louvre.map.adventure." .. tostring(whichchoice) .. ".choice." .. tostring(option), "result " .. b)
						print("setting result", whichchoice, option, "result", b)
					end
				end
			end
		end
	end
end)

add_choice_function("Louvre It or Leave It ", function()
	if not choice_adventure_number then return end
	found = {}
	reached = {}
	available = {}
	available[choice_adventure_number] = -1000
	for i = 1, 1000 do
		old_available = available
		available = {}
		found_any = false
		for choicenum, source in pairs(old_available) do
			found_any = true
			reached[choicenum] = source
			for initialc = 1, 3 do
				initialto = get_ascension_state("louvre.map.adventure." .. tostring(choicenum) .. ".choice." .. tostring(initialc))
				if initialto ~= "" then
					tochoice = initialto:match("^choice ([0-9]+)$")
					toresult = initialto:match("^result (.+)$")
					if tochoice then
						if not reached[tochoice] and not available[tochoice] then
							available[tochoice] = { whichchoice = choicenum, option = initialc }
						end
					end
					if toresult then
						if not found[toresult] then
							found[toresult] = { whichchoice = choicenum, option = initialc }
						end
					end
				end
			end
		end
		if not found_any then
			break
		end
	end
	choice_tbl = {}
	for result, source in pairs(found) do
		function trace(source, tbl)
			if source == -1000 then
				return {}
			else
				tbl = trace(reached[source.whichchoice])
				table.insert(tbl, source)
				return tbl
			end
		end
		local t = trace(source)
		choice_string = text:match([[<input type=hidden name=whichchoice value=]] .. tostring(choice_adventure_number) .. [[><input type=hidden name=option value=]] .. tostring(t[1].option) .. [[><input class=button type=submit value="([^"]+)">]])
		if not choice_tbl[choice_string] then
			choice_tbl[choice_string] = {}
		end
		local tparams = {}
		for a, b in pairs(t) do
			tparams[a] = string.format("choice%d=%d-%d", a, b.whichchoice, b.option)
		end
		local pwd = text:match([[<input type=hidden name=pwd value='([0-9a-f]+)'>]])
		if result == "Gain muscle" then
			result = "<b>" .. result .. "</b>"
		end
		table.insert(choice_tbl[choice_string], [[<a href="automate-louvre?pwd=]] .. pwd .. [[&]] .. table.concat(tparams, "&") .. [[">]] .. result .. [[</a>]])
	end
	for a, b in pairs(choice_tbl) do
		choice_tbl[a] = table.concat(b, ", ")
	end
	return choice_tbl
end)

--~ 	add_choice_function("Louvre It or Leave It ", function()
--~ 		if not choice_adventure_number then return end
--~ 		choice_data = {}
--~ 		for initialc = 1, 3 do
--~ 			initialto = get_ascension_state("louvre.map.adventure." .. tostring(choice_adventure_number) .. ".choice." .. tostring(initialc))
--~ 			result_desc = ""
--~ 			if initialto ~= "" then
--~ 	--~ 		print("initial for", initialc, initialto)
--~ 				tochoice = string.match(initialto, "^choice ([0-9]+)$")
--~ 				toresult = string.match(initialto, "^result (.+)$")
--~ 				if tochoice then
--~ 					can_hit = {}
--~ 					explored = {}
--~ 					results = {}
--~ 					can_hit[tochoice] = true
--~ 					for i = 1, 1000 do -- be absolutely certain to terminate, even if bugged
--~ 						for x, _ in pairs(can_hit) do
--~ 							if not explored[x] then
--~ 	--~ 						print("exploring", x)
--~ 								explored[x] = true
--~ 								for c = 1, 3 do
--~ 									to = get_ascension_state("louvre.map.adventure." .. x .. ".choice." .. tostring(c))
--~ 									if to ~= "" then
--~ 	--~ 								print("hitting", to)
--~ 										tochoice = string.match(to, "^choice ([0-9]+)$")
--~ 										toresult = string.match(to, "^result (.+)$")
--~ 										if tochoice then
--~ 											can_hit[tochoice] = true
--~ 										elseif toresult then
--~ 											results[toresult] = true
--~ 										end
--~ 									end
--~ 								end
--~ 							end
--~ 						end
--~ 					end
--~ 					found_results = {}
--~ 					for a, b in pairs(results) do
--~ 						short_desc = string.match(a, "^[A-Za-z]+ (.+)$")
--~ 						if not short_desc then
--~ 							short_desc = string.match(a, "^<b>[A-Za-z]+ (.+)</b>$")
--~ 							if short_desc then short_desc = "<b>" .. short_desc .. "</b>" end
--~ 						end
--~ 						table.insert(found_results, short_desc)
--~ 					end
--~ 					table.sort(found_results)
--~ 					found_str = ""
--~ 					for _, x in pairs(found_results) do
--~ 						if found_str ~= "" then found_str = found_str .. ", " end
--~ 						found_str = found_str .. x
--~ 					end
--~ 					if found_str == "" then
--~ 						result_desc = "Explore maze"
--~ 					else
--~ 						result_desc = "Explore maze (found: " .. found_str .. ")"
--~ 					end
--~ 				elseif toresult then
--~ 					result_desc = toresult
--~ 				end
--~ 			end
--~ 			choice_string = string.match(text, [[<input type=hidden name=whichchoice value=]] .. tostring(choice_adventure_number) .. [[><input type=hidden name=option value=]] .. tostring(initialc) .. [[><input class=button type=submit value="([^"]+)">]])
--~ 			if choice_string and result_desc ~= "" then
--~ 				choice_data[choice_string] = result_desc
--~ 			end
--~ 		end
--~ 		return choice_data
--~ 	end)

add_interceptor("/automate-louvre", function ()
	text, url = "Trying to automate louvre...", path
	for i = 1, 100 do
		local p = params["choice" .. i]
		if p then
			local whichchoice, option = p:match("([0-9]+)%-([0-9]+)")
--~ 			print(params["choice" .. i], whichchoice, option)
			text, url = post_page("/choice.php", { pwd = params.pwd, whichchoice = whichchoice, option = option })
		else
			break
		end
	end
	return text, url
end)

add_interceptor("/automate-pour-manor-wines", function()
--~ 	posting page /manor3.php params: Just [("action","pourwine"),("whichwine","2271")]
	refresh_inventory()
	local wines_needed_list = get_ascension_state("zone.manor.wines needed")
	if (wines_needed_list == "") then wines_needed_list = {} else wines_needed_list = str_to_table(wines_needed_list) end
	local got = 0
	for _, wine in pairs(wines_needed_list) do
		if have(wine) then
			got = got + 1
		end
	end

	if got == 3 then
		for _, wine in pairs(wines_needed_list) do
			text, url = post_page("/manor3.php", { action = "pourwine", whichwine = tostring(get_itemid(wine)) })
		end
	end
	return text, url
end)
